########################################################################################
#                              Coquillages en Blender/python 
#                                 version 0.91e  mode
#               realise par Cobalt3d alias Jm Soler (08/2000 --> Avril 2008)                             
#---------------------------------------------------------------------------------------                                     
# Script python pour Blender 1.80a et 2.2x    |  Python Script for Blender 1.80a et 2.2x
# test sur Publisher 2.25/blender2.26:2.46   |  tested on Publisher 2.25/blender2.26:2.46
#                                             |  
#---------------------------------------------|-----------------------------------------
# Attention: depuis que les librairies        |   Caution: since python2.2 library
# python2.2 ont un eproblme avec le module   |   has a bug in its "re"  module this
# "re", ce script ne fonctionnait plus        |   script doesn't work correctly due
# correctement  cause de l'utilisation       |   to a problem with the "glob" module.
# du module "glob" qui fasait rfrence       |   This module isn't used anymore and
#  "re". Ce module a t supprim et         |   thus the new version can read and 
# il est de nouveau possible de sauvegarder   |   save config files for new shapes.
# et de relire les fichiers de configuration  |
# pour de nouvelles formes                    |
#                                             |
# La distribution en est libre a condition    | The distribution is free if it is not
# d'etre gratuite. Aucune modification ou     | charged of fee. No paying modification
# utilisation payante ne peut etre effectue.  | and use are allowed.
#                                             |
#
#                                         IMPORTANT!!                                 
#
# Ce script utilise quelques formules         | This script use a few formulas found in:
# trouvees dans:                              |
#
#                                       shelly.c (v1.5)                
#
# l'auteur: Randolf Schultz, s'est lui-meme   | The author : Randolf Schultz is himself 
# inspire de l'article de M.B. Cortie que     | inspired by the M.B. Cortie's paper which
# l'on peut lire dans:                        | is in:
#
#                   Computer&Graphics Vol. 17,No. 1,pp. 79-84, 1993
#                   ("DIGITAL SEASHELLS" by M.B. Cortie.)
#
# pour voir ce qu'est devenu Shelly           | To see the actual Shelly:
# aujourd'hui:                                |
#
#                                 http://www.shelly.de
#  
#                                             |   
#                                             |
#                                             |
# Pour ce script:
#                   Contact: jmsoler@free.fr
#########################################################################################


import Blender
from Blender import NMesh, Object
from Blender.Draw import *
from Blender.BGL import * 
import math
from math import *
import sys
from sys import *     

filename=Blender.Get('filename')

 
modes={'ALL': 32725, #ALL
       'TEX':4,    #TEX
       'TILES':128,  #TILES
       'LIGHT':16,   #LIGHT
       'INVISIBLE':1024, #INVISIBLE
       'COLLISION':1,    #COLLISION
       'SHAREDVERT':64,   #'SHAREDVERT',
       'TWOSIDE':512,  #'TWOSIDE', 
       'OBCOL':2048, #'OBCOL', 
       'HALO':256,  #'HALO', 
       'BILLBOARD':4096, #'BILLBOARD', 
       'SHADOW':8192, #'SHADOW', 
       'TEXT':16384,   #'TEXT',
       'OPAQUE':0,    #'Opaque ',
       'ADD':1,    #'Add ',
       'ALPHA':2,    #'Alpha ',
       'SUB':3,    #'Sub ',
   }
   
#--------------------------------------
# pour avoir un chargement/sauvegarde fichier ordonne
#--------------------------------------
parametresCoquillage=['nom','alpha' ,'beta' ,'phi' ,'my' ,'omega' ,'omin' ,
'omax' ,'smin' ,'smax' ,'A' ,'a' ,'b','P' ,'W1' ,'W2' ,'N' ,'L','od' ,
'sd' ,'Scale','P2','W12','W22','N2','L2','Off2','P3','W13','W23','N3',
'L3','Off3','hdiffo','hdiffs','Scans','Scano','camx','camy',
'camz','mode','Render','col','row','vert']

#-----------------------------------------------------
# masque de dictionnaire standard
#-----------------------------------------------------
V_defaut={'nom':[],'alpha':0.0,'beta':0.0,'phi':0.0,'my':0.0,'omega':0.0,
'omin':0.0,'omax':0.0,'smin':0.0,'smax':0.0,'A':0.0,'a':0.0,'b':0.0,'P':0.0,'W1':0.0,
'W2':0.0,'N':0.0,'L':0.0,'od':0.0,'sd':0.0,'Scale':1.0,'P2':0.0,'W12':0.0,'W22':0.0,
'N2':0.0,'L2':0.0,'Off2':0.0,'P3':0.0,'W13':0.0,'W23':0.0,'N3':0.0,'L3':0.0,'Off3':0.0,
'hdiffo':0.02,'hdiffs':0.02,'Scans':0.02,'Scano':0.02,'camx':0.0,'camy':0.0,
'camz':0.0,'mode':1,'Render':'Blender180a','col':1,'row':1,'vert':1}

#----------------------------------------------------
# fonction copie de dictionnaire standard
#----------------------------------------------------
def dic_copy(d1,d2):
   for clef in d2.keys():
       d1[clef]=d2[clef]

constantes={'DEBUG':0}

constantes['STRING']=1
constantes['BOUTON']=2
constantes['SLIDER']=3
constantes['NOMBRE']=4
constantes['MENU']=5
constantes['TOGGLE']=6
constantes['TEXTE']=7
constantes['TAILLE']=5

constantes['OUT']=0

constantes['LOCALSYS']=1

constantes['COULEUR0']=[0.0,0.0,0.0]
constantes['COULEUR1']=[0.9,0.9,0.5]
constantes['COULEUR2']=[.70,1.0,0.0]
constantes['COULEUR3']=[0.5,0.5,0.0]
constantes['MAGIC']=0
constantes['MOUSE_CTRL']=0
constantes['LAST_FUNCTION']='none'

constantes['PROD_FNCTVAR']=0
constantes['PROD_INTFNCTVAR']=1

constantes['WARNINGS']=0

constantes['VERT_WARNING']=0
constantes['VERT_WARNING_NO']=0
constantes['VERT_WARNING_OK']=0
constantes['VERT_WARNING_NOACT']=0

constantes['PROGRESS_WARNING']=0
constantes['PAINT_PROGRESS_WARNING']=0
constantes['STATE_PROGRESS_WARNING']=0
constantes['STOP_PROGRESS_WARNING']=0

constantes['LOADFILE_WARNING']=0
constantes['LOADFILE_NIVEAU']=0
constantes['MINIMUM']=0
constantes['LIST_RECAP']=1
constantes['LE_GRAND_JEU']=2

constantes['LISTFILE']='Debut du fichier des enregistrements coquillages'
constantes['LISTFILE_END']='Fin du fichier des enregistrements coquillages'


constantes['SAVEFILE_WARNING']=0

constantes['IDENTDATAFILE']='#Fichier de donnees pour Shell/Blender180\n'
constantes['END_IDENTDATAFILE']='#Fin du fichier de donnees pour Shell/Blender180\n'

const=constantes

c0=constantes['COULEUR0']
c1=constantes['COULEUR1']
c2=constantes['COULEUR2']
c3=constantes['COULEUR3']

constantes['COLORNORMAL']=1.0
COLORNORMAL=const['COLORNORMAL']
COLNORMAL=1

#---------------------------------------------------
# Magic line
#--------------------------------------------------

mask_magico={'col':1,'od':0.0,'omin':0.0,'omax':1.0}
mask_magics={'row':1,'sd':0.0,'smin':0.0,'smax':1.0}
magico={'col':1,'od':0.0,'omin':0.0,'omax':1.0}
magics={'row':1,'sd':0.0,'smin':0.0,'smax':1.0}


#---------------------------------------------------
# deboggage
#--------------------------------------------------
if const['DEBUG']==1: 
    l=parametresCoquillage[:]
def test_Ndico(t):
 s=[]
 if const['DEBUG']==1:
    for param in t.keys():
        s.append(param)
        s.append(t[param])
    print s

lname,lpath,lsystem,fname=' ',' ',' ',' '
listfile=[]



def cree_listfile(lpath,listfile):
     recap=lpath+'liste_recap.cqls'
     listfile.sort()
     file_list=open(recap,'w')
     #open(file_list,)
     file_list.write('%s\n' % constantes['LISTFILE'])
     for l in listfile:
        file_list.write('%s\n' % l)
     file_list.write('%s\n' % constantes['LISTFILE_END'])
     file_list.close()


#-------------------------------------------------
# identifier le path et le system 
#-------------------------------------------------

if const['LOCALSYS']:
   if const['DEBUG']: print filename
   #-----------------
   # On tente d'ecrire facilement le fichier dans le meme repertoire que
   # le fichier actuel
   #-----------------
   try:
     import os
     from os import path,name,sep
     lpath,lname=os.path.split(filename)
     lsystem=os.name
     #------------------------------------
     # recupereation des path+noms de fichiers sans glob.glob
     #------------------------------------
     listfile=os.listdir(lpath)
     list2=[]
     for lfile in range(len(listfile)):
         if listfile[lfile].find('.cqlg')!=-1:
            list2.append(listfile[lfile])
     listfile=list2

     print listfile
     #----------------------------------------
     #  reduction aux simples noms 
     #----------------------------------------
     for l in listfile:
         lpat,lnam=os.path.split(l)
         listfile[listfile.index(l)]=lnam 

     print listfile
     lpath=lpath+sep
     #----------------------------------------
     #  mise  jour de la liste recapitulative des fichiers ".cqlg" 
     #----------------------------------------
     cree_listfile(lpath,listfile)    
     

     if lsystem=='nt':
         lsystem='Winnt or something like this' 
     if const['DEBUG']: print lpath, lname 
     constantes['LOADFILE_NIVEAU']=constantes['LE_GRAND_JEU']

   except ImportError:
     #-------------------------- 
     # sinon on essaye de le faire nous meme
     #--------------------------
     def extract_path(f): 
        n0=len(f); 
        sep=['\\','/']
        if filename[0]=='/':
            lsystem='Supposed: Unix or Unix-like'
            sep='/'
        else:
            lsystem='Supposed: Windows or something like this'
            sep='\\'
        for n in range(n0): 
             if f[n0-n-1] in sep:
               p=f[:-n] 
               #print p;
               return p,lsystem,sep

     lpath,lsystem,sep= extract_path(filename)
     lname= filename[len(lpath):]


if constantes['LOADFILE_NIVEAU']<>constantes['LE_GRAND_JEU']:
       recap=lpath+'liste_recap.cqls'  
       try:
       #--------------------------------------------------------------
       # on tente de lire une ancienne sauvegarde ds fichiers raliss
       #--------------------------------------------------------------
         file_list=open(recap,'r')
         line=file_list.readline(); print line[:-1],'.'
         if line[:-1]==constantes['LISTFILE']:
           while line[:-1]<>constantes['LISTFILE_END']:
             line=file_list.readline(); print line[:-1],' ',len(line[:-1]),'.'
             if line[:-1]<>constantes['LISTFILE_END']:
                   listfile.append(line[:-1])
         file_list.close()
       #--------------------------------------------------------------
       # le fichier n'existe mme pas alors on le cre!!
       #--------------------------------------------------------------
       except:
           recap=lpath+'liste_recap.cqls'
           file_list=open(recap,'w')
           #open(file_list,)
           file_list.write('%s\n' % constantes['LISTFILE'])
           file_list.write('%s\n' % constantes['LISTFILE_END'])
           file_list.close()
           listfile=[]

 
print listfile
print constantes['LOADFILE_NIVEAU']

sys.path.append(lpath)



#---------------------------------------------------
# necessaire pour ne pas avoir a gererles valeurs nulles
#---------------------------------------------------
def charge_Ndico(d1,d2):
    for param in d1.keys():
      if d2.has_key(param):
         d1[param]=d2[param] 

#---------------------------------------------------
# donnees de base, les formes originales
#----------------------------------------------------
V_Oxystele={'nom':'Oxystele','alpha':84.9,'beta':7.0,'phi':-36.0,'my':1.0,'omega':-2.0,
'smin':-70.0,'smax':70.0,'sd':10.0,'omin':0.0,'omax':1500.0,'od':40.0,
'A':47.0,'a':40.0,'b':19.0}

V_Nautilus={'nom':'Nautile',
'alpha':80.0,'beta':90.0,'smin':-163.0,
'smax':163.0,'sd':20.0,'omax':800.0,'od':40.0,
'A':2.0,'a':2.0,'b':1.5}

V_Natalina={'nom':'Natalina',
'alpha':80.0,'beta':40.0,'phi':55.0,'my':10.0,'omega':30.0,
'smin':-270.0,'smax':62.0,'sd':20.0,'omax':800.0,'od':20.0,
'A':25.0,'a':12.0,'b':16.0}

V_Ammonite={'nom':'Ammonite','alpha':83.0,'beta':90.0,'phi':1.0,'my':1.0,'omega':1.0,
'smin':-170.0,'smax':170.0,'sd':20.0,'omax':720.0,'od':7.5,'A':2.5,'a':1.0,'b':0.9,
'P':10.0,'W1':100.0,'W2':20.0,'N':15.0,'L':0.5}

V_Lyria={'nom':'Lyria','alpha':83.9,'beta':-19.0,'phi':45.0,'my':1.0,'omega':-2.0,
'smin':-51.0,'smax':9.0,'sd':14.0,'omax':1000.0,'od':20.0,'A':50.0,'a':40.0,
'b':14.0,'W1':6.0,'W2':27.0,'N':8.0,'L':4.0}

D_Oxystele={}
D_Nautilus={}
D_Natalina={}
D_Ammonite={}
D_Lyria={}

dic_copy(D_Oxystele,V_defaut)
dic_copy(D_Nautilus,V_defaut)
dic_copy(D_Natalina,V_defaut)
dic_copy(D_Ammonite,V_defaut)
dic_copy(D_Lyria,V_defaut)

charge_Ndico(D_Oxystele,V_Oxystele)
charge_Ndico(D_Nautilus,V_Nautilus)
charge_Ndico(D_Natalina,V_Natalina)
charge_Ndico(D_Ammonite,V_Ammonite)
charge_Ndico(D_Lyria,V_Lyria)


dico_stnd_shapes={}
dico_stnd_shapes[D_Oxystele['nom']]=D_Oxystele
dico_stnd_shapes[D_Nautilus['nom']]=D_Nautilus
dico_stnd_shapes[D_Natalina['nom']]=D_Natalina
dico_stnd_shapes[D_Ammonite['nom']]=D_Ammonite
dico_stnd_shapes[D_Lyria['nom']]=D_Lyria

#test_Ndico(D_Oxystele)

tooltips={}

tooltips['nom']='Name of shape.'
tooltips['alpha']='Equiangular angle of spiral'
tooltips['beta']='Angle between z-axis and line from aperture local origin to xyz-origin.' 
tooltips['phi']='tilt of ellipse major major axis from horizontal plane.'
tooltips['my']='Amount of "leaning over" of aperture.'
tooltips['omega']='Amount of azimutal rotation of aperture.'
tooltips['omin']='Angle at which spiral begins.'
tooltips['omax']='Angle at which spiral ends.'
tooltips['smin']='Angle at which ellipse/aperture begins.'
tooltips['smax']='Angle at which ellipse/aperture ends.'
tooltips['A']='Distance from main origin of aperture at o=0'
tooltips['a']='Major radius of ellipse.' 
tooltips['b']='Minor radius of ellipse.'
tooltips['P']='Position of nodule.'
tooltips['W1']='Width of nodule in S-direction.'
tooltips['W2']='Width of nodule in O-direction.'
tooltips['N']='Number of nodules per whorl.'
tooltips['L']='Height of nodule at o-0'
tooltips['od']='Stepsize in o-direction.'
tooltips['sd']='Stepsize in s-direction.'
tooltips['Scale']='Scale'
tooltips['P2']='Position of second nodule.'
tooltips['W12']='Width of second nodule in S-direction.'
tooltips['W22']='Width of second nodule in O-direction.'
tooltips['N2']='Number of second nodules per whorl.'
tooltips['L2']='Height of second nodule at o-0'
tooltips['Off2']=' offset of second nodule'
tooltips['P3']='Position of third nodule.'
tooltips['W13']='Width of third nodule in S-direction.'
tooltips['W23']='Width of third nodule in O-direction.'
tooltips['N3']='Number of third nodules per whorl.'
tooltips['L3']='Height of third nodule at o-0'
tooltips['Off3']='Offset of third nodule'
tooltips['col']='Number of colonne'
tooltips['row']='Number of raw'
tooltips['vert']='Number of vertices, caution: less than 65500!!'
tooltips['hdiffo']='Height diff in o direction'	
tooltips['hdiffs']='Height diff in s direction'
tooltips['Scano']='in o direction'	
tooltips['Scans']='in s direction'


#--------------------------------------------------------
# masque de travail interne
#--------------------------------------------------------
coquill_={}
dic_copy(coquill_,D_Lyria)
default={}
dic_copy(default,D_Lyria)

#---------------------------------------------------------
#definition des objets
#---------------------------------------------------------

liste_stnd_shapes=[D_Oxystele['nom'],
                   D_Nautilus['nom'],
                   D_Natalina['nom'],
                   D_Ammonite['nom'],
                   D_Lyria['nom']]

contfenlabel=['txtShell Factory 0.91f','txtCobalt/JmSoler',
                 'txtCurrent shape is  : '+coquill_['nom'],
                      'btnSet current shape as default']
cfl=contfenlabel

contfencontrol=['btnPrev','btnClose','btnMakeit','mnuShapes','btnNext','mnunOk_menu']
cfc=contfencontrol

contfenfile=['strfilename','btnsave','btnload']
cff=contfenfile

contfenvariable=['fenact0','fenact1','fenact2','fenact3','fenlabel',
                 'fencontrol','fencaution','fentimer','fendoc',
                 'fenfileload','fenfilesave']

cfv=contfenvariable

contfenvarname=['btnAngles','btnNodules','btnFilesys']
cfvn=contfenvarname

contfenstdshapes=[]

contenu_type=['variable','statique','action','caution']
ct=contenu_type


Var_fens={}

fenvar0={}
fenvar1={}
fenvar2={}
fenvar3={}
fenvar4={}

fentimer={}
fencaution={}
fendoc={}
fensaveover={}

fenlabel={}
fencontrol={}

plein=[0.0,0.0,1.0,1.0]

def elaboreFenetre(nom,
                   type,
                   contenu,
                   sub_rectgm,
                   maxima,
                   cadre,
                   pos,  
                   couleur,
                   visible,
                   active,
                   modifie,precedente,suivante,fen):
      fen={}
      fen['cadre']=cadre
      fen['type']=type
      fen['pos']=pos
      fen['maxima']=maxima
      fen['contenu']=contenu
      fen['sub_rectg']=sub_rectg
      fen['nom']=nom
      fen['couleur']=couleur
      fen['visible']=visible
      fen['active']=active
      fen['modifie']=modifie
      fen['suivante']=suivante
      fen['precedente']=precedente
      Var_fens[fen['nom']]=fen

#------------------------------------------------
# definition de la fenetre control
#----------------------------------------------
gcontrol=0.4
nom='fencontrol'; type=ct[1]; cadre=[380,56]

c=const['COULEUR1']
couleur=c[0]*gcontrol,c[1]*gcontrol,c[2]*gcontrol

pos=[0,0]; 
active=1; visible=1; modifie=1

ctn=cfvn[:3]+cfc[:5]
#print ctn
contenu=[cfvn[:3]+cfc[:5],
          [2,2,2, 2,2,2,5,2],
          [
          [1,3, 3  ,1.3  ,0 ,1],
          [7,3, 3.2,1.3  ,0 ,1],
          [4,3, 3  ,1.35 ,0 ,1],
          [1,1, 1  ,1.75 ,0 ,0],
          [2,1, 2  ,1.3  ,0 ,0],
          [4,1, 3  ,1.7  ,0 ,0],
          [7,1, 2  ,1    ,0 ,0],
          [9,1, 1.2,1.75 ,0 ,0]
          ],
         
          [9,3],[3,3]]

sub_rectg=[1, [ [plein,couleur] ,
           
               [[0.6,0.4,0.9,1.0],c1],
               [[0.05,0.4,0.6,0.70],c1],
               [[0.05,0.1,1.0,0.40],c0],
               [[0.9,0.4,1.0,1.0],c0]]] 

maxima= [[1,1],[1,1],[1,1],[1,1],[1,1],[1,1],'Shapes %t| Lyria %x1| Nautilus %x2| Oxystele %x3| Ammonite %x4| Natalina %x5 | Default %x6| Nothing %x7',[1,1]]

elaboreFenetre(    nom,
                   type,
                   contenu,
                   sub_rectg,
                   maxima,
                   cadre,
                   pos,  
                   couleur,
                   visible,
                   active,
                   modifie,
                   'none',
                   'act2',
                   fencontrol)
#------------------------------------------------
# Fin de la definition de la fenetre control
#----------------------------------------------

#------------------------------------------------
# definition de la fenetre Timer
#----------------------------------------------

nom='fentimer'; type=ct[0]; cadre=[360,44]
pos=[8,Var_fens['fencontrol']['cadre'][1]+160]; 

gcontrol=0.7
c=[0.7,0.2,0.0]
couleur=c[0]*gcontrol,c[1]*gcontrol,c[2]*gcontrol

active=1; visible=1; modifie=1
contenu=[['txtWarning: Shape Construction'],
         [7],
        [[cadre[0]*0.07,cadre[1]*0.65,.70,.30,.10,0]],
         [1,1],
         [6,6]]
sub_rectg=[1, [[plein,couleur],
              [[0.04,0.18,0.96,0.45],c1] ]]

maxima= [[0.0,0.0]]
              

elaboreFenetre(    nom,
                   type,
                   contenu,
                   sub_rectg,
                   maxima,
                   cadre,
                   pos,  
                   couleur,
                   visible,
                   active,
                   modifie,
                   'none',
                   'none',
                   fentimer)

#------------------------------------------------
# Fin de definition de la fenetre Timer
#----------------------------------------------


#------------------------------------------------
# definition de la fenetre MAxVert
#----------------------------------------------

nom='fencaution';

type=ct[0]; cadre=[196,56]
pos=[64,Var_fens['fencontrol']['cadre'][1]+130]; 

gcontrol=0.9
c=[0.7,0.2,0.0]
couleur=c[0]*gcontrol,c[1]*gcontrol,c[2]*gcontrol

active=1; visible=1; modifie=1
contenu=[['txtCaution: vertices out of limit ','btnOk.','btnNo.'],

         [7,2,2],

        [[cadre[0]*0.07,cadre[1]*0.75,.9,.70,.50],
        [2,1, 1,1.2,0,1],
        [3,1, 1,1.2,0,1]],
         [4,2],
         [6,6]]

sub_rectg=[1, [[plein,couleur]]]

maxima= [[0.0,0.0],[0.0,0.0],[0.0,0.0]]
              

elaboreFenetre(    nom,
                   type,
                   contenu,
                   sub_rectg,
                   maxima,
                   cadre,
                   pos,  
                   couleur,
                   visible,
                   active,
                   modifie,
                   'none',
                   'none',
                   fencaution)

#------------------------------------------------
# Fin de definition de la fenetre Maxvert
#----------------------------------------------


#------------------------------------------------
# definition de la fenetre save file
#----------------------------------------------

nom='fensaveover'; 

type=ct[0]; cadre=[196,56]
pos=[64,Var_fens['fencontrol']['cadre'][1]+130]; 

gcontrol=0.9
c=[0.7,0.2,0.0]
couleur=c[0]*gcontrol,c[1]*gcontrol,c[2]*gcontrol

active=1; visible=1; modifie=1
contenu=[['txtExisting file:?','btnSave over?','btnCancel?'],

         [7,2,2],

        [[cadre[0]*0.07,cadre[1]*0.75,.9,.70,.50],
        [2,1, 1.9,1.2,1,0],
        [4,1, 1.8,1.2,1,0]],
         [4,2],
         [6,6]]

sub_rectg=[1, [[plein,couleur]]]

maxima= [[0.0,0.0],[0.0,0.0],[0.0,0.0]]


elaboreFenetre(    nom,
                   type,
                   contenu,
                   sub_rectg,
                   maxima,
                   cadre,
                   pos,  
                   couleur,
                   visible,
                   active,
                   modifie,
                   'none',
                   'none',
                   fensaveover)

#------------------------------------------------
# Fin de definition de la fenetre save file
#----------------------------------------------

#------------------------------------------------
# definition de la fenetre act0
#----------------------------------------------
nom='fenact0'; type=ct[0]; cadre=[380,260]
pos=[0,Var_fens['fencontrol']['cadre'][1]]; 

gcontrol=0.7
c=const['COULEUR1']
couleur=c[0]*gcontrol,c[1]*gcontrol,c[2]*gcontrol

active=1; visible=1; modifie=1
contenu=[['txtPresentation',
          'txtThis version of the shell factory has been',
          'txtreleased to offer a finest finition for',
          'txtnodules design.',
          'txtThe script works pretty well but there is',
          'txtone problem: the number of vertices.',

          'txtNote that you can  use more than 65500',
          'txtverts or faces, inner limit of blender is',
          'txtvery large (millions) but we set it to',
          'txt128000 in the script.',

          'txtFor this raison the script stops abruptly  ', 
          "txtwhen the limit is overflowed. The shape is",
          'txtcreated and drawed but it takes more time,',
          'txt be patient: 15 or 20 seconds before displaying', 
          'txt"on a p3 600mhz',
          'txtcobalt3d@free.fr' ],
        
          [7,7,7,7,7,7,
           7,7,7,7,7,7,7,7,7,7],
          
          [[cadre[0]*0.051,cadre[1]*0.90,1.0,1.0,1.0,0] , 

[cadre[0]*0.051,cadre[1]*0.80,1.0,1.0,1.0,0], 
[cadre[0]*0.051,cadre[1]*0.75,1.0,1.0,1.0,0], 
[cadre[0]*0.051,cadre[1]*0.70,1.0,1.0,1.0,0], 
[cadre[0]*0.051,cadre[1]*0.65,1.0,1.0,1.0,0], 
[cadre[0]*0.051,cadre[1]*0.60,1.0,1.0,1.0,0], 

[cadre[0]*0.051,cadre[1]*0.53,1.0,1.0,1.0,0], 
[cadre[0]*0.051,cadre[1]*0.48,1.0,1.0,1.0,0], 
[cadre[0]*0.051,cadre[1]*0.43,1.0,1.0,1.0,0], 
[cadre[0]*0.051,cadre[1]*0.38,1.0,1.0,1.0,0], 

[cadre[0]*0.0531,cadre[1]*0.30,1.0,1.0,1.0,0],
[cadre[0]*0.0531,cadre[1]*0.25,1.0,1.0,1.0,0], 
[cadre[0]*0.0531,cadre[1]*0.20,1.0,1.0,1.0,0],
[cadre[0]*0.0531,cadre[1]*0.15,1.0,1.0,1.0,0],
[cadre[0]*0.0531,cadre[1]*0.10,1.0,1.0,1.0,0],
[cadre[0]*0.5,cadre[1]*0.05,1.0,1.0,1.0,0] ], 

          [1,1],[8,8]]



sub_rectg=[1, [[plein,couleur],
              [[0.8,0.0,0.9,1.0],c1],
              [[0.9,0.0,1.0,1.0],c0]]]


maxima= [[0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0],
         [0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0],
         [0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0],
         [0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0]]
              

elaboreFenetre(    nom,
                   type,
                   contenu,
                   sub_rectg,
                   maxima,
                   cadre,
                   pos,  
                   couleur,
                   visible,
                   active,
                   modifie,
                   'fenact3',
                   'fenact1',
                   fenvar0)

#------------------------------------------------
# Fin de la definition de la fenetre act0
#----------------------------------------------


#------------------------------------------------
# definition de la fenetre act1
#----------------------------------------------
nom='fenact1'; type=ct[0]; cadre=[380,260]
pos=[0,Var_fens['fencontrol']['cadre'][1]]; 

gcontrol=0.7
c=const['COULEUR1']
couleur=c[0]*gcontrol,c[1]*gcontrol,c[2]*gcontrol

active=1; visible=1; modifie=1
contenu=[['alpha' ,'beta' ,'phi' ,'my' ,
         'omega' ,'A'     ,'a'   ,'b',
         'omin' ,'hdiffo','omax', 'Scano'  ,
         'od' ,'vert','col','togMo' ,
         'smin' ,'hdiffs','smax', 'Scans' ,
         'sd' ,'togFinest','row','togMs'],

          [3,3,3,3, 
           3,3,3,3, 
           3,3,3,3,
           3,4,4,6, 
           3,3,3,3,
           3,6,4,6],

          [[1,30,2,3,0,0],
           [1,27,2,3,0,0],
           [1,24,2,3,0,0],
           [1,21,2,3,0,0],
                     
           [3,30,2,3,0,0],
           [3,27,2,3,0,0],
           [3,24,2,3,0,0],
           [3,21,2,3,0,0],
                  
           [1,17,2,3,0,0],[3,17,2,3,0,0],
           [1,14,2,3,0,0],[3,14,2,3,0,0],
                      
           [1,11,2,3,0,0],[3,10,1,4,0,0],[4,11,.7,3,0,0],[4,10,.3,4,1,0],
           
           [1,7,2,3,0,0], [3,7,2,3,0,0],
           [1,4,2,3,0,0], [3,4,2,3,0,0],
           
           [1,1,2,3,0,0],[3,1,1,3,0,0],[4,1,.7,3,0,0], [4,1,.3,3,1,0]],

          [4,32],[4,4]]



sub_rectg=[1, [[plein,couleur],
              [[0.6,0.0,0.9,1.0],c1],
              [[0.9,0.0,1.0,1.0],c0]]]


maxima= [ [0.0,89.999],[-180.0,180.0],[-180.0,90.0],[-180.0,180.0],
          [-180.0,180.0],[0.001,100.0],[0.001,100.0],[0.001,100.0],
          [0.0,2400],[0.01,0.05],
          [0.001,2400],[0.01,0.05],
              [0.001,100.0],[1,65530],[1,1024],[1,1],
          [-180.0,180.0],[0.01,0.04],
          [-180.0,180.0],[0.01,0.05],
              [0.01,180.0],[1,1], [1,1024],[1,1]]
              

elaboreFenetre(    nom,
                   type,
                   contenu,
                   sub_rectg,
                   maxima,
                   cadre,
                   pos,  
                   couleur,
                   visible,
                   active,
                   modifie,
                   'fenact0',
                   'fenact2',
                   fenvar1)

#------------------------------------------------
# Fin de la definition de la fenetre act1
#----------------------------------------------


#------------------------------------------------
# definition de la fenetre act2
#----------------------------------------------
nom='fenact2'; type=ct[0]; cadre=Var_fens['fenact1']['cadre']
pos=[0,Var_fens['fencontrol']['cadre'][1]]; 

gcontrol=0.7
c=const['COULEUR1']
couleur=c[0]*gcontrol,c[1]*gcontrol,c[2]*gcontrol

active=1; visible=1; modifie=1

contenu=[['P' ,'W1' ,'W2' ,'N' ,'L','Scale',
          'P2','W12','W22','N2','L2','Off2',
          'P3','W13','W23','N3','L3','Off3'],
           [3,3,3,3,3,3,
            3,3,3,3,3,3, 
            3,3,3,3,3,3],

          [[1,23,1,2,0,1],
           [2,23,1,2,0,1],
           [1,21,1,2,0,1],
           [2,21,1,2,0,1],
           [1,19,1,2,0,1],
           
           [2,1,1.5,2,1,0],

           [1,16,1,2,0,1],
           [2,16,1,2,0,1],
           [1,14,1,2,0,1],
           [2,14,1,2,0,1],
           [1,12,1,2,0,1],
           [2,12,1,2,0,1],
           
           [1,9,1,2,0,1],
           [2,9,1,2,0,1],
           [1,7,1,2,0,1],
           [2,7,1,2,0,1],
           [1,5,1,2,0,1],
           [2,5,1,2,0,1],
         
          ], 

          [2,23],[4,4]]

sub_rectg=[1, [[plein,couleur],
              [[0.6,0.0,0.9,1.0],c1],
              [[0.9,0.0,1.0,1.0],c0]]]

maxima= [[-50.0,50.0],
         [-50.0,50.0],
         [-50.0,50.0],
         [0.0,50.0],
         [-50.0,50.0],
         [0.001,10.0],
         
         [-50.0,50.0],
         [-50.0,50.0],
         [-50.0,50.0],
         [-50.0,50.0],
         [-100.0,100.0],
         [-50.0,50.0],

         [-50.0,50.0],
         [-50.0,50.0],
         [-50.0,50.0],
         [-50.0,50.0],
         [-100.0,100.0],
         [-50.0,50.0]]

elaboreFenetre(    nom,
                   type,
                   contenu,
                   sub_rectg,
                   maxima,
                   cadre,
                   pos,  
                   couleur,
                   visible,
                   active,
                   modifie,
                   'fenact1',
                   'fenact3',
                   fenvar2)

#------------------------------------------------
# Fin de la definition de la fenetre act2
#----------------------------------------------



#------------------------------------------------
# definition de la fenetre act3
#----------------------------------------------
nom='fenact3'; type=ct[0]; cadre=Var_fens['fenact1']['cadre']
pos=[0,Var_fens['fencontrol']['cadre'][1]]; 

gcontrol=0.7
c=const['COULEUR1']
couleur=c[0]*gcontrol,c[1]*gcontrol,c[2]*gcontrol

active=1; visible=1; modifie=1

contenu=[
          [ #contenu[0], identite
          'txtIdentified system:'+lsystem,          #1
          'txtIdentified directory:',               #2
          'strdirectory',                           #3
          'txtIdentified Blender\'s file: '+lname,  #4
          'txtCurrent shape file name:',            #5
          'strfilename',                            #6
          'mnuload',                                #7
          'btnsave',                                #8
          'togConstruction Timer',                  #9
          'togVert Warning',                        #10
          'txtModelling Warnings:',                 #11
          'Max',                                    #12
          
          'txtColor shape',                         #13
          'togMake col'  ,                          #14
          'shape col',                              #15
          
          'fixRcol',                                   #16
          'fixGcol',                                   #17
          'fixBcol',                                   #18
          
          'fixXcol',                                   #19
          'fixYcol',                                   #20
          'fixZcol'                                    #21
          
          
           ],
          
          #----------
          # codes des differents types de boutons
          # 1 = string
          # 2 = button
          # 3 = slider
          # 4 = number
          # 5 = menu
          # 6 = toggle
          # 7 = text
          #--------------
          [ #contenu[1], type de bouton
             7, #1
             7, #2
             1, #3
             7, #4
             7, #5
             1, #6
             5, #7
             2, #8
             6, #9
             6, #10
             7, #11
             4, #12
             7,  #13
             6 , #14

             4 , #14
             
             6 , #15
             6 , #16
             6 ,  #17

             6 , #15
             6 , #16
             6  #17
             
          ],

          [ #contenu[2], localisation
           [cadre[0]*0.051,cadre[1]*0.89,0.6,0.3,0,1], #1
           [cadre[0]*0.051,cadre[1]*0.69,1,1,0,1],     #2
           [0,14,1,2,0,1],                             #3
           [cadre[0]*0.051,cadre[1]*0.80,0.6,0.3,0,1], #4
           [cadre[0]*0.051,cadre[1]*0.50,1,2,0,1],     #5
           [0,10,1,2,0,1],                             #7
           [2,8,1,2,0,1],                              #8
           [1,8,1,2,0,1],                              #9
           [2,4,1,2,0,1],                              #10 
           [2,2,.5,2,0,1],                             #11
           [cadre[0]*0.55,cadre[1]*0.22,0.55,0.3,0,1],  #12
           [2,2,.5,2,1,1],                             #13
           [cadre[0]*0.051,cadre[1]*0.25,0.6,0.3,0,1], #14
           [1    ,4.85 ,  0.39, 1.9, 0, 1],                 #15
           [1.4  ,4.85 ,  0.6, 1.9, 0, 1],                 #15
           
           [1    ,1.6 , .3, 1.8, 0, 1],
           [1.33 ,1.6 , .3, 1.8, 0, 1],
           [1.66 ,1.6 , .3, 1.8, 0, 1],

           [1    ,3.1 , .3, 1.8, 0, 1],
           [1.33 ,3.1 , .3, 1.8, 0, 1],
           [1.66 ,3.1 , .3, 1.8, 0, 1]
           
             ],

          [ #contenu[3], ?
             2,20],
          
          [ #contenu[4], ? 
             4,4]
          ]

sub_rectg=[1, [[plein,couleur],
              [[0.6,0.0,0.9,1.0],c1],
              [[0.9,0.0,1.0,1.0],c0]]]

maxima= [
         [1,1],  #1
         [1,1],  #2
         [1,1],  #3
         [1,1],  #4
         [1,1],  #5
         [1,1],  #6
         ' ',    #7
         [1,1],  #8
         [1,0],  #9
         [1,0],  #10
         [1,1],  #11
         [1,8200],#12
         [1,1],   #12
         [1,1],   #12
         [1,256], #13

         [1,1],   #12
         [1,1],   #12
         [1,1],   #12

         [1,1],   #12
         [1,1],   #12
         [1,1]   #12

         ]


#----------------------------------------------------------
# Mise a jour de la lise d'entree pour le menu load
#-----------------------------------------------------------              
def  mise_a_jour_maximaload(listfile,maxima):
        global nothing2load
        nline=1

        maxima[6]=[]
        maxima[6]='Load file %t|'
        maxima[6]=maxima[6]+'Loaded:'+'CurrentName %x'+str(nline)+'|'

        if listfile<>[]:
           nline=nline+1
           for line in listfile:
              maxima[6]=maxima[6]+'Loaded:'+' '+line+' %x'+str(nline)+'|'
              nline=nline+1
         
        maxima[6]=maxima[6]+'Nothing Loaded %x'+str(nline)
        return nline


nothing2load=mise_a_jour_maximaload(listfile,maxima)

#print maxima

elaboreFenetre(    nom,
                   type,
                   contenu,
                   sub_rectg,
                   maxima,
                   cadre,
                   pos,  
                   couleur,
                   visible,
                   active,
                   modifie,
                   'fenact2',
                   'fenact0',
                   fenvar3)

#------------------------------------------------
# Fin de la definition de la fenetre act3
#----------------------------------------------

#------------------------------------------------
# definition de la fenetre label
#----------------------------------------------
nom='fenlabel'; 
type=ct[1];
cadre=[380,48]
pos=[0,Var_fens['fencontrol']['cadre'][1]+Var_fens['fenact1']['cadre'][1]]

gcontrol=0.5
c=const['COULEUR1']
couleur=c[0]*gcontrol,c[1]*gcontrol,c[2]*gcontrol

active=1; visible=1; modifie=1
contenu=[contfenlabel[:],[7,7,7,2],
                         [[cadre[0]*0.051,cadre[1]*0.65,1.0,1.0,1.0,0],
                         [cadre[0]*0.051,cadre[1]*0.17,0.4,0.3,0.3,0],
                         [cadre[0]*0.43,cadre[1]*0.62,0.5,0.7,0,5],
                          [2,1,1.1,1,1,0]],
[2,2],[8,4]]

sub_rectg=[1, [[plein,couleur],
              [[0.02,0.50,0.4,0.95],c0],
              [[0.4,0.9,0.9,0.95],c0],
              [[0.4,0.4,0.9,0.9],c1],
              [[0.6,0.0,0.9,0.4],c1],
              [[0.9,0.0,1.0,0.950],c0]]]

maxima= [[1,1],[1,1],[1,1],[1,1]]

elaboreFenetre(    nom,
                   type,
                   contenu,
                   sub_rectg,
                   maxima,
                   cadre,
                   pos,  
                   couleur,
                   visible,
                   active,
                   modifie,
                   'none',
                   'none',
                   fenlabel)
#------------------------------------------------
# Fin de la definition de la fenetre label
#----------------------------------------------

def tronque_def_btn(test_btn,n,n1):
    t=[n[0],n[1],n[2]]
    tss=0
    for tss in range(5): 
        if t == test_btn[tss]:
          del n1[1:3]; 
          return 

#----------------------------------------------
#  creation des boutons
#----------------------------------------------
liste_boutons=contfenlabel+contfencontrol+contfenfile+contfenvarname

#------------------------------------------------------------------
# list.index() permet de retrouver une sequence dans une liste mais 
# il faut gerer les exceptions, c'est trop long
#-------------------------------------------------------------------
test_btn=[['s','t','r'],['b','t','n'],['s','l','d'],['n','m','b'],['m','n','u'],['t','x','t']]

nom0=''

dico_boutons={}
index_bouton={}
index=3

def btn_creation(dico_boutons,index_bouton,index):
   # global dico_boutons,index_bouton,index
    for fen in Var_fens.keys():

        t=Var_fens[fen]['contenu'][1]
        #print t
        a=Var_fens[fen]['contenu'][0]
        x=-1
        for t0 in t:
            x=x+1
            if t0<7:
               #print x, t, t0
               if a[x] in default.keys():
                     dico_boutons[a[x]]=Create(default[a[x]])
               else:
                   if (t[x]==1) and (a[x]<>'strdirectory' and a[x]<>'strfilename' ):
                     dico_boutons[a[x]]=Create(a[x][3:])
                     
                   elif a[x]=='strdirectory':
                     dico_boutons[a[x]]=Create(lpath)
                     
                   elif a[x]=='strfilename':
                     dico_boutons[a[x]]=Create(coquill_['nom'])

                   elif a[x]=='shape col':
                     dico_boutons[a[x]]=Create(255)
                     
                   else:
                     dico_boutons[a[x]]=Create(0)
                     
                     if a[x][:3]=='mnu':
                       dico_boutons[a[x]].val=-1
                       
               index_bouton[a[x]]=index
               index=index+1
               if t0==3:
                  if a[x] in default.keys():
                     dico_boutons['re_'+a[x]]=Create(default[a[x]])
                     
                  else:
                     dico_boutons['re_'+a[x]]=Create(0)
                  
                  index_bouton['re_'+a[x]]=index
                  index=index+1
  
#print index

btn_creation(dico_boutons,index_bouton,index)
#t=dico_boutons.keys()
#print index,t

dico_boutons['togFinest'].val=1
dico_boutons['togConstruction Timer'].val=1

  
#-----------------------------------------------
# redefinition de certaines commandes graphiques 
#-----------------------------------------------

glCurseur=glRasterPos2d
glCouleur=glColor3f
glRectangle=glRectf

#-----------------------------------------------
# fin de la redefinition de certaines commandes graphiques 
#-----------------------------------------------

def affiche_bouton(nom,type,lieu,index,ecart,dico_bouton):
      global tooltips
      nom0='nul'

      lieu=[int(lint) for lint in lieu]
      
 
      if type==1:
         n=nom
         t=[n[0],n[1],n[2]]
         tss=0
         for tss in range(5): 
           if t == test_btn[tss]:
             nom0=nom[3:] 
             break

         dico_bouton[nom]=String(nom0+": ", index,lieu[0],lieu[1],lieu[2],lieu[3],dico_bouton[nom].val,54)
         return

      if type==2:
         n=nom
         t=[n[0],n[1],n[2]]
         tss=0
         for tss in range(5): 
           if t == test_btn[tss]:
             nom0=nom[3:] 
             break
         if nom in tooltips.keys():
             dico_bouton[nom]=Button(nom0, index,lieu[0],lieu[1],lieu[2],lieu[3],tooltips[nom])
         else:
             dico_bouton[nom]=Button(nom0, index,lieu[0],lieu[1],lieu[2],lieu[3])
 
         return

      if type==3:
          if nom in tooltips.keys():
            t=tooltips[nom]
            #print nom
            dico_bouton[nom]=Slider(nom+":", index,
                       lieu[0],lieu[1],int(lieu[2]*0.9),lieu[3],
                       dico_bouton[nom].val, ecart[0],ecart[1],0,
                       t)

            dico_bouton['re_'+nom]=Button("R",
                                       index_bouton['re_'+nom],
                                       int(lieu[0]+lieu[2]*0.9),
                                       lieu[1],
                                       int(lieu[2]*0.1),
                                       lieu[3], tooltips[nom])
          else:
            dico_bouton[nom]=Slider(nom+":", index,
                       lieu[0],lieu[1],int(lieu[2]*0.9),lieu[3], dico_bouton[nom].val, ecart[0],ecart[1],0)

            dico_bouton['re_'+nom]=Button("R",index_bouton['re_'+nom],
                                       int(lieu[0]+lieu[2]*0.9),lieu[1],int(lieu[2]*0.1),lieu[3])
          return
      
      if type==4:
         if nom in tooltips.keys():
            dico_bouton[nom]=Number(nom+":", index,lieu[0],lieu[1],lieu[2],lieu[3],dico_bouton[nom].val, ecart[0],ecart[1],tooltips[nom])
         else:
            dico_bouton[nom]=Number(nom+":", index,lieu[0],lieu[1],lieu[2],lieu[3],dico_bouton[nom].val, ecart[0],ecart[1])
         return 
      
      if type==5:
         dico_bouton[nom]=Menu(ecart,index,lieu[0],lieu[1],lieu[2],lieu[3],dico_bouton[nom].val)
         return 
      
      if type==6:
         nom0=nom[3:] 
         dico_bouton[nom]=Toggle(nom0, index,lieu[0],lieu[1],lieu[2],lieu[3],dico_bouton[nom].val)
         return

      if type==7:
         glColor3f(lieu[0],lieu[1],lieu[2])
         glRasterPos2d(ecart[0],ecart[1])
         Text(nom)
         return 

nom1=''

def trace_rectangle(rh,rv,dr,r,c):
    glCouleur(c[0],c[1],c[2])
    glRectangle(rh*r[0]+dr[0],rv*r[1]+dr[1],
                rh*r[2]+dr[0],rv*r[3]+dr[1])

def affiche_fen(f):  
    global nom1
    
    v=Var_fens[f]['visible']
    m=Var_fens[f]['modifie']    
    
    if (m==1 and v==1):
       c=Var_fens[f]['couleur']
       cd=Var_fens[f]['cadre']
       Lg=cd[0]
       lg=cd[1]

       p=Var_fens[f]['pos']
       glCouleur(c[0],c[1],c[2])
       glRectangle(p[0],p[1],cd[0]+p[0],cd[1]+p[1])
       
       r=Var_fens[f]['sub_rectg']
       #print r
       if r[0]>0:
         for t_r in r[1]:
             #print f,t_r
             trace_rectangle(Lg,
                            lg,
                            p,
                            t_r[0],t_r[1])

       if  Var_fens[f]['contenu'][0]<>[]:
          l_b=Var_fens[f]['contenu'][0]

          l_type= Var_fens[f]['contenu'][1]
          l_pos= Var_fens[f]['contenu'][2]
          l_frc= Var_fens[f]['contenu'][3]
          l_ect= Var_fens[f]['maxima']

          vspace=Var_fens[f]['contenu'][4][1]
          hspace=Var_fens[f]['contenu'][4][0]

          i=0

          hcell=(Lg-hspace)/l_frc[0]
          vcell=(lg-vspace)/l_frc[1]

          for lst in l_b:
            #print lst
            if l_type[i]<>const['TEXTE']: 
              l=[0,0,0,0]
              if l_pos[i][0]<>0:
                 l[2]=hcell*l_pos[i][2]-hspace
                 if l_pos[i][4]==1: 
                   l[0]=p[0]+hcell*l_pos[i][0]-l[2]
                 else:
                   l[0]=p[0]+hcell*(l_pos[i][0]-1)+hspace
              else:
                 l[2]=cd[0]-2*hspace
                 l[0]=p[0]+hspace
                 
              if l_pos[i][1]<>0:   
                 l[3]=vcell*l_pos[i][3]-vspace
                 if l_pos[i][5]==1: 
                   l[1]=p[1]+vcell*l_pos[i][1]-l[3]+vspace
                 else:
                   l[1]=p[1]+vcell*(l_pos[i][1]-1)+vspace
              else:
                 l[3]=cd[1]-2*vspace
                 l[1]=p[1]+vspace

              index=2
              nom1=lst
            else:
              l=[l_pos[i][2],l_pos[i][3],l_pos[i][4]]
              index=0
              l_ect[i][0]=l_pos[i][0]+p[0]
              l_ect[i][1]=l_pos[i][1]+p[1]
              nom1=lst[3:]

            if index_bouton.has_key(nom1): 
                      index=index_bouton[nom1]

            affiche_bouton(nom1,  l_type[i],  l, index  ,  l_ect[i],dico_boutons)
            i=i+1


rct=[[0.0,0.0,0.0,0.0],[0.0,0.0,0.0]]

def actualise_ecran():                
    global fenetres,const
  
    if not const['WARNINGS']:
          glClearColor(0.7,1.0,0.90,0.0)
          glClear(GL_COLOR_BUFFER_BIT)
    
          for fenetre in Var_fens.keys():
             affiche_fen(fenetre)
    else:
       if constantes['SAVEFILE_WARNING']:
           etat_fen('fensaveover',1,1,1)
           affiche_fen('fensaveover')
           etat_fen('fensaveover',0,0,0)
           return

       if const['VERT_WARNING']:
           etat_fen('fencaution',1,1,1)
           affiche_fen('fencaution')
           etat_fen('fencaution',0,0,0)
           return

       elif const['PAINT_PROGRESS_WARNING']:
           trace_rectangle(1,1,[0,0],rct[0],rct[1])
           #print rct[0]
           return

       elif const['PROGRESS_WARNING']:
           etat_fen('fentimer',1,1,1)
           affiche_fen('fentimer')
           etat_fen('fentimer',0,0,0)

           const['PAINT_PROGRESS_WARNING']=1
           const['PROGRESS_WARNING']=0

           p=Var_fens['fentimer']['pos']
           cd=Var_fens['fentimer']['cadre']
           Lg=cd[0]
           lg=cd[1]
           r=Var_fens['fentimer']['sub_rectg'][1][1]

           rct[0]=[r[0][0]*Lg+p[0],
                   r[0][1]*lg+p[1],
                   r[0][0]*Lg+p[0],
                   r[0][3]*lg+p[1]]
           
           rct[1]=[1,0.5,0.3]   

           return

       
 
   
def etat_fen(nom,et1,et2,et3):
    global Var_fens 
    Var_fens[nom]['modifie']=et1
    Var_fens[nom]['visible']=et2
    Var_fens[nom]['active']=et3
 
constantes['ACTIVEFEN']=cfv[0]
constantes['DefaultACTFEN']=['fenlabel','fencontrol']

def masque_fen():
    for fenetre in Var_fens.keys():
       if (fenetre in constantes['DefaultACTFEN']) or (fenetre==constantes['ACTIVEFEN']):
           etat_fen(fenetre, 1, 1, 1)
       else:
           etat_fen(fenetre, 0, 0, 0)
    actualise_ecran()
    


#----------------------------------------------------------------------------------
# fonctions de calcul de forme
#----------------------------------------------------------------------------------


def construit_faces(n1,n2,me,list1,list2):
   n_1=n1;n_2=n2  
   if n_1==n_2:
     n1=len(me.verts)-(n1+n2)
     n2=len(me.verts)-n2
     
     n3=0
       
     while n3<(n2-(n1+1)):
         f=NMesh.Face()  
         f.v.append(me.verts[n1+n3])  
         f.v.append(me.verts[n1+n3+1])  
         f.v.append(me.verts[n2+n3])  
           
         me.faces.append(f)
         
         f1=NMesh.Face()  
         f1.v.append(me.verts[n1+n3+1])  
         f1.v.append(me.verts[n2+n3+1])  
         f1.v.append(me.verts[n2+n3])  
           
         me.faces.append(f1) 
         n3=n3+1
         
   else:
  
     l1,l2=0,0
     
     n1=len(me.verts)-(n1+n2)
     n2=len(me.verts)-n2


     while (l1<n_1-1) and (l2<n_2-1):
          if (list1[l1+1]>=list2[l2+1]) and (list1[l1]<=list2[l2]):
             f=NMesh.Face()  
             f.v.append(me.verts[n1+l1])
             f.v.append(me.verts[n1+l1+1])
             f.v.append(me.verts[n2+l2+1])
               
             me.faces.append(f) 
               
             f=NMesh.Face()  
             f.v.append(me.verts[n1+l1])
             f.v.append(me.verts[n2+l2+1])
             f.v.append(me.verts[n2+l2])
               
             me.faces.append(f) 
             l1,l2=l1+1,l2+1
          
          elif (list1[l1+1]<=list2[l2+1]):
               
             f=NMesh.Face()  
             f.v.append(me.verts[n1+l1+1])
             f.v.append(me.verts[n2+l2+1])
             f.v.append(me.verts[n2+l2])
               
             me.faces.append(f) 
             
             f=NMesh.Face()  
             f.v.append(me.verts[n1+l1])
             f.v.append(me.verts[n1+l1+1])
             f.v.append(me.verts[n2+l2])
               
             me.faces.append(f)
             l1,l2=l1+1,l2+1
           
             while list1[l1]<list2[l2]:
               f=NMesh.Face()  
               f.v.append(me.verts[n1+l1])
               f.v.append(me.verts[n1+l1+1])
               f.v.append(me.verts[n2+l2])
                 
               me.faces.append(f)
               l1=l1+1
       
          elif (list1[l1]>list2[l2]) :   
             while list1[l1]>list2[l2]:
               f=NMesh.Face()  
               f.v.append(me.verts[n1+l1])
               f.v.append(me.verts[n2+l2+1])
               f.v.append(me.verts[n2+l2])
                 
               me.faces.append(f)
               l2=l2+1
     
     if l2<n_2-1:
         f=NMesh.Face()  
         f.v.append(me.verts[n1+n_1-1])
         f.v.append(me.verts[n2+n_2-2])
         f.v.append(me.verts[n2+n_2-1])
           
         me.faces.append(f)
         
         f=NMesh.Face()  
         f.v.append(me.verts[n1+n_1-1])
         f.v.append(me.verts[n2+n_2-2])
         f.v.append(me.verts[n2+n_2-3])
           
         me.faces.append(f)
         
     elif l1<n_1-1:
         f=NMesh.Face()  
         f.v.append(me.verts[n2+n_2-1])
         f.v.append(me.verts[n1+n_1-2])
         f.v.append(me.verts[n1+n_1-1])
           
         me.faces.append(f)
         
         f=NMesh.Face()  
         f.v.append(me.verts[n2+n_2-1])
         f.v.append(me.verts[n1+n_1-2])
         f.v.append(me.verts[n1+n_1-3])
           
         me.faces.append(f)

def cot(in_):
    if sin(in_)==0.0:
      return(0.0)
    else:
      return(cos(in_)/sin(in_))

def calcg(O,N):
  if (N == 0.0):
    return(0.0)
  else:
    return((2.0*pi)/N*(O*N/(2.0*pi)-round(O*N/(2.0*pi))))


def calck (Coquill_,S,O):
 # global N, N2, N3, L, L2, L3, W1, W2, W12, W13, W22, W23, P, P2, P3, Off2, Off3, calledk
  k=0.0
  g=0.0

  N = Coquill_['N']
  W1 = Coquill_['W1'] * pi / 180.0
  W2 = Coquill_['W2'] * pi / 180.0
  P = Coquill_['P'] * pi / 180.0
  L = Coquill_['L']

  N2 = Coquill_['N2']
  W12 = Coquill_['W12'] * pi / 180.0
  W22 = Coquill_['W22'] * pi / 180.0
  P2 = Coquill_['P2'] * pi / 180.0
  L2 = Coquill_['L2']

  N3 = Coquill_['N3']
  W13 = Coquill_['W13'] * pi / 180.0
  W23 = Coquill_['W23'] * pi / 180.0
  P3 = Coquill_['P3'] * pi / 180.0
  L3 = Coquill_['L3']

  Off2 = Coquill_['Off2'] * pi / 180.0
  Off3 = Coquill_['Off3'] * pi / 180.0

  g=calcg(O,N)
  if (N!=0):
    if (W2==0.0) or (W1==0.0):
        k=0
    else:
       k=L*exp(-(2*(S-P)/W1)*(2*(S-P)/W1))*exp(-(2*g/W2)*(2*g/W2))
    
  g=calcg(O+Off2,N2)
  if (N2!=0):
    if (W22==0.0) or (W12==0.0):
         k=0
    else:
         k=k+(L2*exp(-(2*(S-P2)/W12)*(2*(S-P2)/W12))*exp(-(2*g/W22)*(2*g/W22)))
 
  g=calcg (O + Off3, N3)
  if (N3 != 0.0):
    if (W23==0) or (W13==0):
      k=0
    else:
      k=k+(L3*exp(-(2*(S-P3)/W13)*(2*(S-P3)/W13))*exp(-(2*g/W23)*(2*g/W23)))

  return(k)

def calcline (O, Coquill_, me):

  smin=Coquill_['smin']*pi/180.0
  smax=Coquill_['smax']*pi/180.0
  sd=Coquill_['sd']*pi/180.0

  alpha=Coquill_['alpha']*pi/180.0
  beta=Coquill_['beta']*pi/180.0
  phi=Coquill_['phi']*pi/180.0
  omega=Coquill_['omega']*pi/180.0
  my=Coquill_['my']*pi/180.0

  a = Coquill_['a'];
  b = Coquill_['b'];
  A = Coquill_['A'];

  Scale = Coquill_['Scale']
    
  counth = 0;
  if not dico_boutons['togMo'].val:
    S = smin
    while (S)<=smax:
      counth=counth+1

      Re = pow((pow(a,-2.0)*(cos(S)*cos(S))+pow(b,-2.0)*(sin(S)*sin(S))),-0.5)
      k=calck(Coquill_,S,O);
      R=Re+k;
      
      # alternatively: 
      # R = pow((pow(a,2.0)*pow(cos(S),2.0)+pow(b,2.0)*pow(sin(S),2.0)),0.5); 

      x=Scale*(A*sin(beta)*cos(O)+R*cos(S+phi)*cos(O+omega)-R*sin(my)*sin(S+phi)*sin(O))*exp(O*cot(alpha))
      y=Scale*(-1*A*sin(beta)*sin(O)-R*cos(S+phi)*sin(O+omega)-R*sin(my)*sin(S+phi)*cos(O))*exp(O*cot(alpha))
      z=Scale*(-1*A*cos(beta)+R*sin(S+phi)*cos(my))*exp(O*cot(alpha))

      v=NMesh.Vert(x,y,z)
      me.verts.append(v)
      S = S + sd
  else:
      S = smin
      counth=counth+1

      Re = pow((pow(a,-2.0)*(cos(S)*cos(S))+pow(b,-2.0)*(sin(S)*sin(S))),-0.5)
      k=calck(Coquill_,S,O);
      R=Re+k;
      
      # alternatively: 
      # R = pow((pow(a,2.0)*pow(cos(S),2.0)+pow(b,2.0)*pow(sin(S),2.0)),0.5); 

      x=Scale*(A*sin(beta)*cos(O)+R*cos(S+phi)*cos(O+omega)-R*sin(my)*sin(S+phi)*sin(O))*exp(O*cot(alpha))
      y=Scale*(-1*A*sin(beta)*sin(O)-R*cos(S+phi)*sin(O+omega)-R*sin(my)*sin(S+phi)*cos(O))*exp(O*cot(alpha))
      z=Scale*(-1*A*cos(beta)+R*sin(S+phi)*cos(my))*exp(O*cot(alpha))

      v=NMesh.Vert(x,y,z)
      me.verts.append(v)
      S = S + sd
      counth=counth+1

      Re = pow((pow(a,-2.0)*(cos(S)*cos(S))+pow(b,-2.0)*(sin(S)*sin(S))),-0.5)
      k=calck(Coquill_,S,O);
      R=Re+k;
      
      # alternatively: 
      # R = pow((pow(a,2.0)*pow(cos(S),2.0)+pow(b,2.0)*pow(sin(S),2.0)),0.5); 

      x=Scale*(A*sin(beta)*cos(O)+R*cos(S+phi)*cos(O+omega)-R*sin(my)*sin(S+phi)*sin(O))*exp(O*cot(alpha))
      y=Scale*(-1*A*sin(beta)*sin(O)-R*cos(S+phi)*sin(O+omega)-R*sin(my)*sin(S+phi)*cos(O))*exp(O*cot(alpha))
      z=Scale*(-1*A*cos(beta)+R*sin(S+phi)*cos(my))*exp(O*cot(alpha))

      v=NMesh.Vert(x,y,z)
      me.verts.append(v)

  return(counth)


def CalcShell(Coquill_,me):
     global omin,omax,od,const
     list1,list2=[],[]
     O=0.0
     omin = Coquill_['omin'] * pi / 180.0
     omax = Coquill_['omax'] * pi / 180.0
     od =  Coquill_['od'] * pi / 180.0
     
     n1=calcline (omin, Coquill_, me)


     if not dico_boutons['togMs'].val:
        print const['PAINT_PROGRESS_WARNING']
        if const['PAINT_PROGRESS_WARNING']:
           p=Var_fens['fentimer']['pos']
           Lg=Var_fens['fentimer']['cadre'][0]
           r=Var_fens['fentimer']['sub_rectg'][1][1]
           r0=r[0][0]*Lg
           r1=r[0][2]*Lg
           r2=r1-r0
           Draw()
        speed=2
        O = omin
        while (O < omax):
           counth = 0
           n2=calcline(O, Coquill_, me)
           construit_faces(n1,n2,me,list1,list2)
           n1=n2
           O = O + od
           speed=speed+1
           if (speed % 4)==0 and const['PAINT_PROGRESS_WARNING']:
              rct[0][0]=rct[0][2]
              rct[0][2]=r0+O/omax*r2+p[0]
              Draw()
        if const['PAINT_PROGRESS_WARNING']:
              rct[0][0]=rct[0][2]
              rct[0][2]=r0+r2+p[0]
              Draw()
     else:
        O=omin+od
        n2=calcline(O, Coquill_, me)
        construit_faces(n1,n2,me,list1,list2)

  
     const['PAINT_PROGRESS_WARNING']=0
     constantes['STOP_PROGRESS_WARNING']=0
        
     maxx=-10000.00
     minx=10000.00
     maxy=-10000.00
     miny=10000.00
     maxz=-10000.00
     minz=10000.00

     for m0 in me.verts:
          if (m0.co[0]<=minx):
                minx=m0.co[0]
          if (m0.co[0]>=maxx):
                maxx=m0.co[0]
          if (m0.co[1]<=miny):
                miny=m0.co[1]
          if (m0.co[1]>=maxy):
                maxy=m0.co[1]
          if (m0.co[2]<=minx):
                minz=m0.co[2]
          if (m0.co[2]>=maxz):
                maxz=m0.co[2]

     scaval=1.0    
     if const['MAGIC']:
        scaval=0.8
     else:
        scaval=const['TAILLE']


     if abs(maxx-minx)!=0.0: 
        mscalex=scaval/abs(maxx-minx)
     else:
        mscalex=scaval

     if abs(maxy-miny)!=0.0: 
        mscaley=scaval/abs(maxy-miny)
     else:
        mscaley=scaval

     if abs(maxz-minz)!=0.0: 
        mscalez=scaval/abs(maxz-minz)
     else:
        mscalez=scaval

     mscale=(mscaley+mscalex+mscalez)/3

     decx=(minx+maxx)/2*mscale
     decy=(miny+maxy)/2*mscale
     decz=(minz+maxz)/2*mscale
 
     for m0 in me.verts:
         m0.co[0]=m0.co[0]*mscale-decx
         m0.co[1]=m0.co[1]*mscale-decy
         m0.co[2]=m0.co[2]*mscale-decz


def innodule2 (Coquill_, sc, O, S):
     k1 = 0.0
     k2 = 0.0
     k1 = calck (Coquill_, S, O)
     k2 = calck (Coquill_, S + sc, O)
     return (abs(k1) - abs(k2));

def calcnews(Coquill_,O,Sold):
    S=Sold
    mittenodul=0
    sd=Coquill_['sd']*pi/180;
    S=S+Coquill_['Scans']
    while ((abs(innodule2(Coquill_,S-Sold,O,Sold))<Coquill_['hdiffs']) and (S-Sold<sd) and (mittenodul==0)):
          S=S+Coquill_['Scans']
          if ((innodule2(Coquill_,Coquill_['Scans'],O,Sold)<0) and (innodule2(Coquill_,Coquill_['Scans'],O,S)>0)):
            mittenodul=1;
    if S>Coquill_['smax']*pi/180:
       S=Coquill_['smax']*pi/180
       return S
    return S

def calcpoint(O,S,Coquill_,me,list):

    if (len(me.verts)+1)>65500:
        print 'error: too much vertices.'
        const['OUT']=1
    else: 
        alpha=Coquill_['alpha']*pi/180.0
        beta=Coquill_['beta']*pi/180.0
        phi=Coquill_['phi']*pi/180.0
        omega=Coquill_['omega']*pi/180.0
        my=Coquill_['my']*pi/180.0
        a = Coquill_['a'];
        b = Coquill_['b'];
        A = Coquill_['A'];
        Scale = Coquill_['Scale']

        Re=pow((pow(a,-2.0)*(cos(S)*cos(S))+pow(b,-2.0)*(sin(S)*sin(S))),-0.5);
        k=calck(Coquill_,S,O);
        R=Re+k;

        #alternatively:*/
        #R=pow((pow(a,2.0)*pow(cos(S),2.0)+pow(b,2.0)*pow(sin(S),2.0)),0.5);*/

        x=Scale*(A*sin(beta)*cos(O)+R*cos(S+phi)*cos(O+omega)-R*sin(my)*sin(S+phi)*sin(O))*exp(O*cot(alpha));
        y=Scale*(-1*A*sin(beta)*sin(O)-R*cos(S+phi)*sin(O+omega)-R*sin(my)*sin(S+phi)*cos(O))*exp(O*cot(alpha));
        z=Scale*(-1*A*cos(beta)+R*sin(S+phi)*cos(my))*exp(O*cot(alpha));

        v=NMesh.Vert(x,y,z)
        me.verts.append(v)
        list.append(S)
    
    #calcpoint*/

def calcnodline(O,Coquill_,me,list):
    smin=Coquill_['smin']*pi/180;
    smax=Coquill_['smax']*pi/180;
    sd=Coquill_['sd']*pi/180;
    sc=Coquill_['Scans']
    S=smin;
    counth=0
    calcpoint(O,smin,Coquill_,me,list);
    counth=1
    if not const['OUT']:
      while (S<smax):
          newS=calcnews(Coquill_,O,S)
          S=newS
          if S<=smax:
            calcpoint(O,S,Coquill_,me,list)
            counth=counth+1
          if const['OUT']: break
    else: print 'Value out of range: vertices or faces limit.'
    return(counth);

#calcnodline*/

def innodule(Coquill_,sc,O):
    k1=0.0
    k2=0.0
    g=0.0
    N=Coquill_['N'];
    W2=Coquill_['W2']*pi/180;
    L=Coquill_['L'];
    N2=Coquill_['N2'];
    W22=Coquill_['W22']*pi/180;
    L2=Coquill_['L2'];
    N3=Coquill_['N3'];
    W23=Coquill_['W23']*pi/180;
    L3=Coquill_['L3'];
    Off2=Coquill_['Off2']*pi/180;
    Off3=Coquill_['Off3']*pi/180;

    g=calcg(O,N);
    if (N!=0) and (W2!=0): 
         k1=L*exp(-(2*g/W2)*(2*g/W2));
    else: k1=0.0
    g=calcg(O+Off2,N2);
    if (N2!=0) and (W22!=0):
      k1=k1+(L2*exp(-(2*g/W22)*(2*g/W22)));
    else: k1=0.0
    g=calcg(O+Off3,N3);
    if(N3!=0) and (W23!=0):
      k1=k1+(L3*exp(-(2*g/W23)*(2*g/W23)));
    else: k1=0.0
    g=calcg(O+sc,N);
    if(N!=0) and (W2!=0):
       k2=L*exp(-(2*g/W2)*(2*g/W2));
    else: k2=0.0
    g=calcg(O+Off2+sc,N2);
    if(N2!=0) and (W22!=0):
       k2=k2+(L2*exp(-(2*g/W22)*(2*g/W22)));
    else: k2=0.0
    g=calcg(O+Off3+sc,N3);
    if(N3!=0) and (W23!=0):
       k2=k2+(L3*exp(-(2*g/W23)*(2*g/W23)));
    else: k2=0.0
    return(abs(k1)-abs(k2));
#innodule*/

def calcnewo(Coquill_,Oold,newO):
    O=Oold
    od=0.0
    mittenodul=0
    od=Coquill_['od']*pi/180
    O=O+Coquill_['Scano']
    if O>Coquill_['omax']*pi/180:
       O=Coquill_['omax']*pi/180
       newO=O
       return newO
    else:
      while((abs(innodule(Coquill_,O-Oold,Oold))<Coquill_['hdiffo']) and (O-Oold<od) and (mittenodul==0)):
        O=O+Coquill_['Scano']
        if ((innodule(Coquill_,Coquill_['Scano'],Oold)<0) and (innodule(Coquill_,Coquill_['Scano'],O)>0)):
           mittenodul=1
      newO=O
      return newO

def CalcNodule(Coquill_, me):

     list1=[]
     list2=[]

     omin=Coquill_['omin']*pi/180;
     omax=Coquill_['omax']*pi/180;
     O=omin;
     newO=O

     test=0
     speed=2
     #print const['PAINT_PROGRESS_WARNING']
     if const['PAINT_PROGRESS_WARNING']:
          p=Var_fens['fentimer']['pos']
          Lg=Var_fens['fentimer']['cadre'][0]
          r=Var_fens['fentimer']['sub_rectg'][1][1]
          r0=r[0][0]*Lg
          r1=r[0][2]*Lg
          r2=r1-r0
           
          Draw()

     n1=calcnodline(omin,Coquill_, me,list1)

     while (O<=omax):
        
        newO=calcnewo(Coquill_,O, newO)
        O=newO; 
        
        #print O, omax
        n2=calcnodline(O,Coquill_,me,list2);
        
        #print n2,n1
        if (((n2+n1)+len(me.faces))<128000) and not const['OUT']:
           construit_faces(n1,n2,me,list1,list2)
           list1=[]
           list1=list2[:]
           list2=[]
           n1=n2
           speed=speed+1
           if (speed % 4)==0 and const['PAINT_PROGRESS_WARNING']:
              rct[0][0]=rct[0][2]
              rct[0][2]=r0+O/omax*r2+p[0]
              Draw()
        else:
           const['OUT']=1
           print 'Error:maximum faces overflow. Break in calcnodule'
           break

     if const['PAINT_PROGRESS_WARNING']:
            rct[0][0]=rct[0][2]
            rct[0][2]=r0+r2+p[0]
            Draw()

     const['PAINT_PROGRESS_WARNING']=0
     constantes['STOP_PROGRESS_WARNING']=0
      
     maxx=-10000.00
     minx=10000.00
     maxy=-10000.00
     miny=10000.00
     maxz=-10000.00
     minz=10000.00
     
     for m0 in me.verts:
          if (m0.co[0]<=minx):
                minx=m0.co[0]
          if (m0.co[0]>=maxx):
                maxx=m0.co[0]
          if (m0.co[1]<=miny):
                miny=m0.co[1]
          if (m0.co[1]>=maxy):
                maxy=m0.co[1]
          if (m0.co[2]<=minx):
                minz=m0.co[2]
          if (m0.co[2]>=maxz):
                maxz=m0.co[2]

     scaval=1.0    
     if const['MAGIC']:
        scaval=1.2
     else:
        scaval=const['TAILLE']

     mscalex=scaval/abs(maxx-minx)
     mscaley=scaval/abs(maxy-miny)
     mscalez=scaval/abs(maxz-minz)
     mscale=(mscaley+mscalex+mscalez)/3

     decx=(minx+maxx)/2*mscale
     decy=(miny+maxy)/2*mscale
     decz=(minz+maxz)/2*mscale
 
     for m0 in me.verts:
         m0.co[0]=m0.co[0]*mscale-decx
         m0.co[1]=m0.co[1]*mscale-decy
         m0.co[2]=m0.co[2]*mscale-decz
         
        

#CalcNodule*/

def coquillage(Coquill_):
    me=NMesh.GetRaw()
    if dico_boutons['togFinest'].val:
      CalcNodule(Coquill_,me)
    else:
      CalcShell(Coquill_,me)
    Coquill_['vert']=len(me.verts)
    dico_boutons['vert'].val=coquill_['vert']
    # for f in me.faces:
    #    f.smooth=1
    NMesh.PutRaw(me,"shell",1)         
    me2=NMesh.GetRaw("shell")

    if dico_boutons['togMake col'].val==1:    
       SIZE_X=dico_boutons['shape col'].val
       if me2.hasFaceUV()==0:
          #print me2.hasFaceUV()
          for f in me2.faces:
              #if len(f.v)>=3: 
                 f.smooth=1 
                 if len(f.v)==3:
                     f.uv = [(0.0,0.0),(1.0,0.0),(0.0,1.0)]
                 else:
                     f.uv = [(0.0,0.0),(1.0,0.0),(1.0,1.0),(0.0,1.0)]
       for f in me2.faces:
              for ncol in range(len(f.v)):            
                   ndv=abs(f.v[ncol].no[0]*f.v[ncol].no[0]+\
                                f.v[ncol].no[1]*f.v[ncol].no[1]+\
                                f.v[ncol].no[2]*f.v[ncol].no[2])
                   if ndv==0.0:
                        ndv=1.0         
                   ndirect=-1.0
                   if dico_boutons['fixXcol'].val==1:
                      ndirect=f.v[ncol].no[0]
                   if dico_boutons['fixYcol'].val==1:
                      ndirect=f.v[ncol].no[1]
                   if dico_boutons['fixZcol'].val==1:
                      ndirect=f.v[ncol].no[2]
                   if dico_boutons['fixRcol'].val ==1:
                      r=255
                   elif ndirect>-1.0:
                      r=abs(int(ndirect*SIZE_X))
                   else:   
                      r=abs(int(f.v[ncol].no[0]*SIZE_X))
                      
                   if dico_boutons['fixGcol'].val ==1:
                      g=255
                   elif ndirect>-1.0:
                      g=abs(int(ndirect*SIZE_X))
                   else : 
                      g=abs(int(f.v[ncol].no[1]*SIZE_X))
                      
                   if dico_boutons['fixBcol'].val ==1:
                      b=255
                   elif ndirect>-1.0: 
                      b=abs(int(ndirect*SIZE_X))
                   else:   
                      b=abs(int(f.v[ncol].no[2]*SIZE_X))
                   a=0
                   f.col.append(NMesh.Col(r, g, b))
    else:
       for f in me2.faces:
          if len(f.v)==3:
                     f.uv = [(0.0,0.0),(1.0,0.0),(0.0,1.0)]
          elif len(f.v)==4:
                     f.uv = [(0.0,0.0),(1.0,0.0),(1.0,1.0),(0.0,1.0)]
          f.smooth=1

    for f in me2.faces:
          f.mode =modes['TEX']+modes['TWOSIDE']-1
	
    Mesh=Blender.Object.Get('Mesh')
    Mesh=NMesh.PutRaw(me2,"shell")
    
    
    
    Blender.Redraw()
    Draw()
    if const['OUT']: Exit()



def makecolor():
    pass
    
#-------------------------------------------------------------------------------
#     Definition des fonctions attachees aux boutons
##--------------------------------------------------------------------------------




def fnct_btnNext():
    fen=Var_fens[constantes['ACTIVEFEN']]
    if fen['suivante']<>'none':
       constantes['ACTIVEFEN']=fen['suivante']
       masque_fen()
       #Redraw()
       Draw()
    #print 'next'

def fnct_btnPrev():
    fen=Var_fens[constantes['ACTIVEFEN']]
    if fen['precedente']<>'none': 
       constantes['ACTIVEFEN']=fen['precedente']
       masque_fen()
       Draw()
    #print 'prev'


def fnct_btnMakeit_or_not():
    if dico_boutons['togVert Warning'].val==1:
       print 'ok toggle'
       if dico_boutons['vert'].val>dico_boutons['Max'].val:
          constantes['WARNINGS']=1
          constantes['VERT_WARNING']=1
          constantes['LAST_FUNCTION']='btnMakeit'
          Draw()
       else: 
          index_function['btnMakeit']()
    else: 
       index_function['btnMakeit']()
                 

def fnct_btnMakeit():
    if dico_boutons['togConstruction Timer'].val:
         constantes['WARNINGS'],constantes['PROGRESS_WARNING']=1,1
         Draw()    
         coquillage(coquill_)
         constantes['WARNINGS'],constantes['PROGRESS_WARNING']=0,0
         Draw()    
    else:
           coquillage(coquill_)
          

#fonctions 
index_function={}

    
index_function['btnNext']=fnct_btnNext
index_function['btnPrev']=fnct_btnPrev
index_function['btnMakeit']=fnct_btnMakeit

def doc_vert():    
        dico_boutons['vert'].val=(coquill_['col']+1)*(coquill_['row']+1)

        if dico_boutons['togVert Warning'].val==1:
          if dico_boutons['vert'].val>dico_boutons['Max'].val:
               constantes['WARNINGS']=1
               constantes['VERT_WARNING']=1
               constantes['VERT_WARNING_NOACT']=1

maxbverts=65000

def details(u):
    if u=='col':
        coquill_['od']=Osteps(dico_boutons['col'].val,0)
        dico_boutons['od'].val=coquill_['od']
        doc_vert()
        if dico_boutons['vert'].val>maxbverts:
           coquill_['col']=maxbverts/(coquill_['row']+1)
           dico_boutons['col'].val=coquill_['col']           
           coquill_['od']=Osteps(dico_boutons['col'].val,0)
           doc_vert()
        return

    elif u=='od': 
        coquill_['col']=int(Osteps(0,1))
        dico_boutons['col'].val=coquill_['col']
        doc_vert()
        if dico_boutons['vert'].val>maxbverts:
           coquill_['col']=maxbverts/(coquill_['row']+1)
           dico_boutons['col'].val=coquill_['col']           
           coquill_['od']=Osteps(dico_boutons['col'].val,0)
           doc_vert()
        return

    elif u=='row':
        coquill_['sd']=Ssteps(dico_boutons['row'].val,0)
        dico_boutons['sd'].val=coquill_['sd']
        doc_vert()
        if dico_boutons['vert'].val>maxbverts:
           coquill_['row']=maxbverts/(coquill_['col']+1)
           dico_boutons['row'].val=coquill_['row']          
           coquill_['sd']=Ssteps(dico_boutons['row'].val,0)
           doc_vert()
        return
    
    elif u=='sd': 
        coquill_['row']=int(Ssteps(0,1))
        if coquill_['row']>255:coquill_['row']=127 
        dico_boutons['row'].val=coquill_['row']
        doc_vert()
        if dico_boutons['vert'].val>maxbverts:
           coquill_['row']=maxbverts/(coquill_['col']+1)
           dico_boutons['row'].val=coquill_['row']           
           coquill_['sd']=Ssteps(dico_boutons['row'].val,0)
           doc_vert()

        return
    
    elif u=='omax' or u=='omin':
       
            coquill_['od']=Osteps(dico_boutons['col'].val,0)
            dico_boutons['od'].val=coquill_['od']
            doc_vert()
            if dico_boutons['vert'].val>maxbverts:
               coquill_['col']=maxbverts/(coquill_['row']+1)
               dico_boutons['col'].val=coquill_['col']           
               coquill_['od']=Osteps(dico_boutons['col'].val,0)
               doc_vert()
            return
        


    elif u=='smax' or u=='min':
        coquill_['sd']=Ssteps(dico_boutons['row'].val,0)
        dico_boutons['sd'].val=coquill_['sd']
        doc_vert()
        if dico_boutons['vert'].val>maxbverts:
           coquill_['row']=maxbverts/(coquill_['col']+1)
           dico_boutons['row'].val=coquill_['row']           
           coquill_['sd']=Ssteps(dico_boutons['row'].val,0)
           doc_vert()
        return

   

def upset_u(u):
    #print u
    coquill_[u]=dico_boutons[u].val
    details(u)
    if const['MAGIC']: 
      coquillage(coquill_)
    else:
       Draw()

def reset_u(u):
    dico_boutons[u].val=default[u]
    upset_u(u)   

#fonction numero. 1
def fnct_strdirectory():
    pass
    
index_function['strdirectory']=fnct_strdirectory
    
#fonction numero. 2
def fnct_mnuShapes():
    
    l=['Lyria','Nautile','Oxystele','Ammonite','Natalina']
    s=dico_boutons['mnuShapes'].val
    if s<6:
       reset(dico_stnd_shapes[l[s-1]])
       Var_fens['fenlabel']['contenu'][0][2]='txtCurrent shape is  : '+coquill_['nom']
       dico_boutons['strfilename'].val=coquill_['nom']
       
    elif s==6:
       dic_copy(coquill_,default)
       Var_fens['fenlabel']['contenu'][0][2]='txtCurrent shape is  : '+coquill_['nom']
       dico_boutons['strfilename'].val=coquill_['nom']
    else:
       pass
    Draw()
    
index_function['mnuShapes']=fnct_mnuShapes
    
#fonction numero. 3
def fnct_btnClose():
    Exit()
    
index_function['btnClose']=fnct_btnClose



    
#fonction numero. 4
def fnct_btnAngles():
    if constantes['ACTIVEFEN']<>'fenact1': 
       constantes['ACTIVEFEN']='fenact1'
       masque_fen()
       Draw()
    
index_function['btnAngles']=fnct_btnAngles



    
#fonction numero. 5
def fnct_btnNodules():
    if constantes['ACTIVEFEN']<>'fenact2': 
       constantes['ACTIVEFEN']='fenact2'
       masque_fen()
       Draw()
    
index_function['btnNodules']=fnct_btnNodules



    
#fonction numero. 6
def fnct_strfilename():
       coquill_['nom']=dico_boutons['strfilename'].val
       Var_fens['fenlabel']['contenu'][0][2]='txtCurrent shape is  : '+coquill_['nom']
       Draw()
    
    
index_function['strfilename']=fnct_strfilename
    
#fonction numero. 7
def fnct_btnSet_current_shape_as_default():
    dic_copy(default,coquill_)
    Draw()
    pass
    
index_function['btnSet current shape as default']=fnct_btnSet_current_shape_as_default

#fonction numero. 10
def fnct_btnFilesys():
    if constantes['ACTIVEFEN']<>'fenact3': 
       constantes['ACTIVEFEN']='fenact3'
       masque_fen()
       Draw()
    
index_function['btnFilesys']=fnct_btnFilesys


#--------------------------------------------------------
# fonctions en cours d'implementation
#--------------------------------------------------------
    
#fonction numero. 8
def fnct_btnsave():
    save_shape(lpath,lsystem,sep)
    
index_function['btnsave']=fnct_btnsave
    
#fonction numero. 9
def fnct_mnuload():
  if constantes['LOADFILE_NIVEAU']<>constantes['MINIMUM']:
    sf=dico_boutons['mnuload'].val

    if sf==1:
      load_shape(lpath,lsystem,sep,dico_boutons['strfilename'].val+'.cqlg')
      if const['DEBUG']: print dico_boutons['strfilename'].val+'.cqlg'

    elif sf==nothing2load:
      return

    elif (sf>1) and (sf<nothing2load):
      load_shape(lpath,lsystem,sep,listfile[sf-2])
      print listfile[sf-2]

    else:
      return

  else:
    pass


index_function['mnuload']=fnct_mnuload

#fonction de limitation de vertices
def fnct_Max():
    pass
index_function['Max']=fnct_Max

def fnct_shapecol():
    pass
index_function['shape col']=fnct_shapecol

def fnct_Makcolorshape():
   print '   makecolor()'

index_function['togMake col']=fnct_Makcolorshape

def fnct_fixR():
    pass
index_function['fixRcol']=fnct_fixR

def fnct_fixG():
    pass
index_function['fixGcol']=fnct_fixG

def fnct_fixB():
    pass
index_function['fixBcol']=fnct_fixB

def fnct_fixX():
    pass
index_function['fixXcol']=fnct_fixX

def fnct_fixY():
    pass
index_function['fixYcol']=fnct_fixY

def fnct_fixZ():
    pass
index_function['fixZcol']=fnct_fixZ

def fnct_togConstruction_Timer():
    constantes['PROGRESS_WARNING']=dico_boutons['togConstruction Timer'].val
    print constantes['PROGRESS_WARNING']
    pass

index_function['togConstruction Timer']=fnct_togConstruction_Timer

  
def fnct_togVert_Warning():
    pass

index_function['togVert Warning']=fnct_togVert_Warning

def bascule_masqmagic_o():
   if dico_boutons['togMo'].val==1:
   
      for nom in magico.keys():
          magico[nom]=default[nom]
      
      magics['sd']=(dico_boutons['smax'].val-dico_boutons['smin'].val)/100
      magics['smin']=dico_boutons['smin'].val
      magics['smax']=dico_boutons['smin'].val+dico_boutons['sd'].val*1.1
      magics['row']=1
   
      for nom in mask_magico.keys():
          dico_boutons[nom].val=magico[nom]
          coquill_[nom]=magico[nom]
   
      for nom in mask_magics.keys():
          dico_boutons[nom].val=magics[nom]
          coquill_[nom]=magics[nom]
   else:
      for nom in magico.keys():
          dico_boutons[nom].val=default[nom]
          coquill_[nom]=default[nom]
      if dico_boutons['togMs'].val==0:
         for nom in magics.keys():
             dico_boutons[nom].val=default[nom]
             coquill_[nom]=default[nom]
   


def bascule_masqmagic_s():
   if dico_boutons['togMs'].val==1:

      for nom in magics.keys():
          magics[nom]=default[nom]

      magico['od']=(dico_boutons['omax'].val-dico_boutons['omin'].val)/100
      magico['omin']=dico_boutons['omin'].val
      magico['omax']=dico_boutons['omin'].val+dico_boutons['od'].val*1.1
      magico['col']=1
      
      
      for nom in magico.keys():
          dico_boutons[nom].val=magico[nom]
          coquill_[nom]=magico[nom]
   
      for nom in magics.keys():
          dico_boutons[nom].val=magics[nom]
          coquill_[nom]=magics[nom]

   else:
      for nom in magics.keys():
          dico_boutons[nom].val=default[nom]
          coquill_[nom]=default[nom]
      if dico_boutons['togMo'].val==0:
         for nom in magico.keys():
             dico_boutons[nom].val=default[nom]
             coquill_[nom]=default[nom]

          


  
def fnct_togMo():
   if dico_boutons['togMs'].val==1:
         dico_boutons['togMs'].val=0
         bascule_masqmagic_s()
      
   if dico_boutons['togMo'].val==0:
         bascule_masqmagic_o()
   else:
      dico_boutons['togMo'].val==0
      bascule_masqmagic_o()
   Draw()

   if (dico_boutons['togMo'].val==1) or (dico_boutons['togMs'].val==1):
      const['MAGIC']=1
   else:
      const['MAGIC']=0

   coquillage(coquill_)

index_function['togMo']=fnct_togMo


def fnct_togMs():
    if dico_boutons['togMo'].val==1:
         dico_boutons['togMo'].val=0
         bascule_masqmagic_o()
    if dico_boutons['togMs'].val==0:
      bascule_masqmagic_s()
    else:
      dico_boutons['togMo'].val==0
      bascule_masqmagic_s()
         
    Draw()
    if (dico_boutons['togMo'].val==1) or (dico_boutons['togMs'].val==1):
       const['MAGIC']=1
    else:
       const['MAGIC']=0

    coquillage(coquill_)


index_function['togMs']=fnct_togMs


def fnct_btnStop():
    constantes['STOP_PROGRESS_WARNING']=1
    pass

index_function['btnStop']=fnct_btnStop

def fnct_togFinest():
    pass

index_function['togFinest']=fnct_togFinest

#fonction numero. Ok
def fnct_btnOk():
    constantes['WARNINGS']=0
    constantes['VERT_WARNING']=0
    constantes['VERT_WARNING_OK']=1
    Draw()
    if constantes['VERT_WARNING_NOACT']==0:
           fnct_btnMakeit()
    else:
           constantes['VERT_WARNING_NOACT']=0 
    
index_function['btnOk.']=fnct_btnOk

#fonction numero. No
def fnct_btnNo():
    constantes['WARNINGS']=0
    constantes['VERT_WARNING']=0
    constantes['VERT_WARNING_NO']=1
    Draw()
    
    
index_function['btnNo.']=fnct_btnNo

def accepted_saveover():
    global fname
    print fname,' test2'
    file=open(fname,'w') 
    save(coquill_,file)
    file.close()
    ajoute2listfichier(dico_boutons['strfilename'].val+'.cqlg',listfile,lpath)
    Draw()

#fonction numero. Ok
def fnct_btnSave_over():
    constantes['WARNINGS']=0
    Draw()
    constantes['SAVEFILE_WARNING']=0
    accepted_saveover()
   
index_function['btnSave over?']=fnct_btnSave_over

#fonction numero. Ok
def fnct_btnCancel():
    constantes['WARNINGS']=0
    Draw()
    constantes['SAVEFILE_WARNING']=0
    
index_function['btnCancel?']=fnct_btnCancel

#--------------------------------------------------------
# fonctions en cours d'implementation
#--------------------------------------------------------


def Osteps(col0,flag):
    t1=coquill_['omax']
    t2=coquill_['omin']
    t3=coquill_['od']
    if flag==1:  
       return((t1-t2)/t3)
    else:
       return ((t1-t2)/col0)


def Ssteps(row,flag):
    t1=coquill_['smax']
    t2=coquill_['smin']
    t3=coquill_['sd']

    if flag==1:  
       return((t1-t2)/t3)
    else:
       return((t1-t2)/row)

def reset(Coquill_):
          for param in Coquill_.keys():
                if param in dico_boutons.keys(): dico_boutons[param].val=Coquill_[param]
                if ('btn'+param) in dico_boutons.keys(): dico_boutons['btn'+param].val=Coquill_[param]
                
          dic_copy(default,Coquill_)
          dic_copy(coquill_,default)

          coquill_['row']=int(Ssteps(0,1))
          dico_boutons['row'].val=coquill_['row']
          coquill_['col']=int(Osteps(0,1))
          dico_boutons['col'].val=coquill_['col']
          
          Var_fens['fenlabel']['contenu'][0][2]='txtCurrent shape is  : '+coquill_['nom']
          dico_boutons['strfilename'].val=coquill_['nom']
    
          fnct_btnMakeit_or_not()
    
              
def upset_coquillage(coquill_):
    l=coquill_.keys()
    for param in l:
          coquill_[param]=dico_boutons[param].val
          default[param]=dico_boutons[param].val

          


def init_ecran():
    glClearColor(0.7,1.0,0.90,0.0)
    glClear(GL_COLOR_BUFFER_BIT)
    masque_fen()


init_ecran()

coquill_['col']=int(Osteps(coquill_['od'],1))
coquill_['row']=int(Ssteps(coquill_['sd'],1))
coquill_['vert']=coquill_['row']*coquill_['col']
reset(coquill_)



def load(File,Coquill_):
    l,l0='',''
    l=File.readline()
    if not constantes['DEBUG']:print 'l=',l
    if l==constantes['IDENTDATAFILE']:
        if not constantes['DEBUG']:print l
        dic_copy(coquill_,V_defaut)
        while 1:
            l=File.readline()
            if l==constantes['END_IDENTDATAFILE']:
              if not constantes['DEBUG']:print l
              return
            if l[:-1] in parametresCoquillage:
                l0=File.readline()
                if not constantes['DEBUG']:print l0
                if (l[:-1]=='nom') or (l[:-1]=='Render'):
                   coquill_[l[:-1]]=l0[:-1]
                else:
                   coquill_[l[:-1]]=eval(l0[:-1])
                l=[]
                l0=[]
            else:
                print 'File corrupted or not complete'
                return
    else:
        print 'Not a Shell/blender file or file corrupted!'
        return


def save(Coquill_,File):
    #--------------------------------
    # on teste toutes les entrees non nulles ou egales a zero 
    # possibles du dico coquillage
    #--------------------------------
    File.write("%s" % constantes['IDENTDATAFILE'])
    for n in parametresCoquillage:
       if (Coquill_[n]<>0) or (Coquill_[n]<>0.0): 
         print n,'  :',Coquill_[n]
         File.write('%s\n'  % n)
         File.write('%s\n'  % Coquill_[n])
    File.write("%s\n" % constantes['END_IDENTDATAFILE'])
    #--------------------------------------
    #
    #--------------------------------------

def ajoute2listfichier(name,listfile,lpath):
     global nothing2load
     maximum=Var_fens['fenact3']['maxima']

     if constantes['LOADFILE_NIVEAU']==constantes['MINIMUM']:
        listfile.append(name)
        cree_listfile(lpath,listfile)
        if not const['DEBUG']:print listfile
        nothing2load=mise_a_jour_maximaload(listfile,maximum)
        constantes['LOADFILE_NIVEAU']==constantes['LIST_RECAP']

     else:
       if name not in listfile:
          listfile.append(name)
          cree_listfile(lpath,listfile)
          if not const['DEBUG']:print listfile
          nothing2load=mise_a_jour_maximaload(listfile,maximum)


def save_shape(lpath,lsystem,sep):
    global fname
    n=lpath[len(lpath)-1]

    if (lsystem=='Supposed: Unix or Unix-like') or (lsystem=='posix'):
       sep='/'
    else:
       if (lsystem=='Supposed: Winn or something like this') or(lsystem=='nt'):
           sep='\\'

    if  n not in ['\\','/']:
       lpath=lpath+sep

    fname=lpath+dico_boutons['strfilename'].val+'.cqlg'

    print fname,' test1'
    
    #---------------------------------------
    #teste presence du fichier a sauvegarder
    #---------------------------------------
    if dico_boutons['strfilename'].val+'.cqlg' in listfile:
       #------------------------------------------------------------
       # le fichier est dans la liste 
       #------------------------------------------------------------
       constantes['WARNINGS']=1
       constantes['SAVEFILE_WARNING']=1
       Draw()

    else:
       #----------------------------------------------
       # il y q une erreur donc ce fichier n'existe pas dans le repertoire 
       # courant: on ajoute le nom de ce fichier a la liste 
       #----------------------------------------------
       file=open(fname,'w') 
       save(coquill_,file)
       file.close()
       ajoute2listfichier(dico_boutons['strfilename'].val+'.cqlg',listfile,lpath)

      
def load_shape(lpath,lsystem,sep,filename):
    n=lpath[len(lpath)-1]
    print sep,n
    if sep not in ['\\','/']:
      if (lsystem=='Supposed: Unix or Unix-like') or (lsystem=='posix'):
       sep='/'
      else:
       if (lsystem=='Supposed: Winnt or something like this') or(lsystem=='nt'):
           sep='\\'
      print n
    if  n not in ['\\','/']:
        lpath=lpath+sep
    
    fname=lpath+filename
    
    print fname
    
    #---------------------------------------
    #teste presence du fichier a sauvegarder
    #---------------------------------------
    try:
       file=open(fname,'r') 
       #------------------------------------------------------------
       # pas d'exception donc le fichier existe, faut-il ecraser le fichier? 
       #------------------------------------------------------------
       load(file,coquill_)
       file.close()
       reset(coquill_)
          

    except:
       print 'no such file or directory!'

def draw():
    actualise_ecran()    

def event(evt, val):
    if (evt== QKEY and not val): 
         Exit()
    elif (evt== MIDDLEMOUSE):
          if constantes['MOUSE_CTRL']:
             fnct_btnMakeit_or_not()
             constantes['MOUSE_CTRL']=0
             return

          else:
             constantes['MOUSE_CTRL']=1

    elif (evt== LEFTARROWKEY): 
          index_function['btnPrev']()
          return

    elif (evt== RIGHTARROWKEY): 
          index_function['btnNext']()
          return

    elif (evt== MKEY): 
          index_function['btnMakeit']()
          return
    elif (evt== AKEY): 
          index_function['btnAngles']()
          return
    elif (evt== NKEY): 
          index_function['btnNodules']()
          return
    elif (evt== FKEY): 
          index_function['btnFilesys']()


def bevent(evt):
    global index_function
    if   (evt== 1): Exit()
    elif (evt== 2): Draw()
    
    for param in index_bouton.keys():
        if const['DEBUG']:print param
        if evt==index_bouton[param]:
             if param in coquill_.keys():
                upset_u(param)
                return
             elif (param>3) and (param[:3]=='re_') and (param[3:]in coquill_.keys()):
                reset_u(param[3:])
                return
             elif (param>3) and (param[:3]=='btn') and (param[3:]in coquill_.keys()):
                upset_u(param[3:])
                return
             else:
                if param=='btnMakeit': 
                   fnct_btnMakeit_or_not()
                else:
                   index_function[param]()


Register(draw, event, bevent)